--- old/usr/src/uts/common/io/fibre-channel/fca/qlc/ql_api.c	Mon Aug  5 17:28:23 2019
+++ new/usr/src/uts/common/io/fibre-channel/fca/qlc/ql_api.c	Mon Aug  5 17:28:23 2019
@@ -10851,7 +11238,7 @@
 {
 	int rval;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
 	if (CFG_IST(ha, CFG_SBUS_CARD)) {
 		ql_write_flash_byte(ha, 0x5555, 0xa0);
@@ -10871,7 +11258,7 @@
 		EL(ha, "failed=%xh\n", rval);
 	} else {
 		/*EMPTY*/
-		QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+		QL_PRINT_3(ha, "done\n");
 	}
 	return (rval);
 }
@@ -10900,10 +11287,9 @@
 	uint8_t		*bfp;
 	uint8_t		*tmp;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
 	if ((CFG_IST(ha, CFG_SBUS_CARD)) && !erase_all) {
-
 		if (ql_flash_sbus_fpga == 1) {
 			ssize = QL_SBUS_FCODE_SIZE;
 			sStartAddr = QL_FCODE_OFFSET;
@@ -10918,7 +11304,7 @@
 
 		/* Save the section of flash we're not updating to buffer */
 		tmp = bfp;
-		for (cnt = sStartAddr; cnt < ssize+sStartAddr; cnt++) {
+		for (cnt = sStartAddr; cnt < ssize + sStartAddr; cnt++) {
 			/* Allow other system activity. */
 			if (cnt % 0x1000 == 0) {
 				ql_delay(ha, 10000);
@@ -10925,45 +11311,50 @@
 			}
 			*tmp++ = (uint8_t)ql_read_flash_byte(ha, cnt);
 		}
-	}
 
-	/* Chip Erase Command Sequence */
-	ql_write_flash_byte(ha, 0x5555, 0xaa);
-	ql_write_flash_byte(ha, 0x2aaa, 0x55);
-	ql_write_flash_byte(ha, 0x5555, 0x80);
-	ql_write_flash_byte(ha, 0x5555, 0xaa);
-	ql_write_flash_byte(ha, 0x2aaa, 0x55);
-	ql_write_flash_byte(ha, 0x5555, 0x10);
+		/* Chip Erase Command Sequence */
+		ql_write_flash_byte(ha, 0x5555, 0xaa);
+		ql_write_flash_byte(ha, 0x2aaa, 0x55);
+		ql_write_flash_byte(ha, 0x5555, 0x80);
+		ql_write_flash_byte(ha, 0x5555, 0xaa);
+		ql_write_flash_byte(ha, 0x2aaa, 0x55);
+		ql_write_flash_byte(ha, 0x5555, 0x10);
 
-	ql_delay(ha, erase_delay);
+		ql_delay(ha, erase_delay);
 
-	/* Wait for erase to complete. */
-	rval = ql_poll_flash(ha, 0, 0x80);
+		/* Wait for erase to complete. */
+		rval = ql_poll_flash(ha, 0, 0x80);
 
-	if (rval != QL_SUCCESS) {
-		EL(ha, "failed=%xh\n", rval);
-		if (CFG_IST(ha, CFG_SBUS_CARD)) {
-			kmem_free(bfp, ssize);
-		}
-		return (rval);
-	}
-
-	/* restore the section we saved in the buffer */
-	if ((CFG_IST(ha, CFG_SBUS_CARD)) && !erase_all) {
-		/* Restore the section we saved off */
-		tmp = bfp;
-		for (cnt = sStartAddr; cnt < ssize+sStartAddr; cnt++) {
-			/* Allow other system activity. */
-			if (cnt % 0x1000 == 0) {
-				ql_delay(ha, 10000);
+		if (rval == QL_SUCCESS) {
+			/* Restore the section we saved off */
+			tmp = bfp;
+			for (cnt = sStartAddr; cnt < ssize + sStartAddr;
+			    cnt++) {
+				/* Allow other system activity. */
+				if (cnt % 0x1000 == 0) {
+					ql_delay(ha, 10000);
+				}
+				rval = ql_program_flash_address(ha, cnt,
+				    *tmp++);
+				if (rval != QL_SUCCESS) {
+					break;
+				}
 			}
-			rval = ql_program_flash_address(ha, cnt, *tmp++);
-			if (rval != QL_SUCCESS) {
-				break;
-			}
 		}
-
 		kmem_free(bfp, ssize);
+	} else {
+		/* Chip Erase Command Sequence */
+		ql_write_flash_byte(ha, 0x5555, 0xaa);
+		ql_write_flash_byte(ha, 0x2aaa, 0x55);
+		ql_write_flash_byte(ha, 0x5555, 0x80);
+		ql_write_flash_byte(ha, 0x5555, 0xaa);
+		ql_write_flash_byte(ha, 0x2aaa, 0x55);
+		ql_write_flash_byte(ha, 0x5555, 0x10);
+
+		ql_delay(ha, erase_delay);
+
+		/* Wait for erase to complete. */
+		rval = ql_poll_flash(ha, 0, 0x80);
 	}
 
 	if (rval != QL_SUCCESS) {
@@ -10970,7 +11361,7 @@
 		EL(ha, "failed=%xh\n", rval);
 	} else {
 		/*EMPTY*/
-		QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+		QL_PRINT_3(ha, "done\n");
 	}
 	return (rval);
 }
@@ -10997,7 +11388,7 @@
 	uint32_t	cnt;
 	int		rval = QL_FUNCTION_FAILED;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
 	poll_data = (uint8_t)(poll_data & BIT_7);
 
@@ -11019,7 +11410,7 @@
 		EL(ha, "failed=%xh\n", rval);
 	} else {
 		/*EMPTY*/
-		QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+		QL_PRINT_3(ha, "done\n");
 	}
 	return (rval);
 }
@@ -11039,7 +11430,7 @@
 {
 	uint16_t	data;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
 	/* Enable Flash Read/Write. */
 	if (CFG_IST(ha, CFG_SBUS_CARD)) {
@@ -11065,7 +11456,7 @@
 	}
 	(void) ql_read_flash_byte(ha, 0);
 
-	QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_3(ha, "done\n");
 }
 
 /*
@@ -11083,7 +11474,7 @@
 {
 	uint16_t	data;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
 	if (CFG_IST(ha, CFG_SBUS_CARD)) {
 		/*
@@ -11103,7 +11494,7 @@
 		WRT16_IO_REG(ha, ctrl_status, data);
 	}
 
-	QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_3(ha, "done\n");
 }
 
 /*
@@ -11137,7 +11528,7 @@
 		/* Setup bit 16 of flash address. */
 		bank_select = (uint16_t)RD16_IO_REG(ha, ctrl_status);
 
-		if (CFG_IST(ha, CFG_CTRL_6322)) {
+		if (ha->device_id == 0x2322 || ha->device_id == 0x6322) {
 			bank_select = (uint16_t)(bank_select & ~0xf0);
 			bank_select = (uint16_t)(bank_select |
 			    ((addr >> 12 & 0xf0) | ISP_FLASH_64K_BANK));
@@ -11199,7 +11590,7 @@
 
 		/* Setup bit 16 of flash address. */
 		bank_select = RD16_IO_REG(ha, ctrl_status);
-		if (CFG_IST(ha, CFG_CTRL_6322)) {
+		if (ha->device_id == 0x2322 || ha->device_id == 0x6322) {
 			bank_select = (uint16_t)(bank_select & ~0xf0);
 			bank_select = (uint16_t)(bank_select |
 			    ((addr >> 12 & 0xf0) | ISP_FLASH_64K_BANK));
@@ -11251,14 +11642,19 @@
 	ql_adapter_state_t	*ha = vha->pha;
 	ql_xioctl_t		*xp = ha->xioctl;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
 	rval = ql_24xx_read_flash(ha, FLASH_CONF_ADDR | 0x3AB, &fdata);
-
-	if (rval != QL_SUCCESS || fdata == 0 || CFG_IST(ha, CFG_CTRL_2581)) {
+	if (CFG_IST(ha, CFG_CTRL_24XX)) {
+		if (rval != QL_SUCCESS || fdata == 0) {
+			fdata = 0;
+			rval = ql_24xx_read_flash(ha, FLASH_CONF_ADDR | 0x39F,
+			    &fdata);
+		}
+	} else {
 		fdata = 0;
 		rval = ql_24xx_read_flash(ha, FLASH_CONF_ADDR |
-		    (CFG_IST(ha, CFG_CTRL_2422) ? 0x39F : 0x49F), &fdata);
+		    (CFG_IST(ha, CFG_CTRL_25XX) ? 0x49F : 0x39F), &fdata);
 	}
 
 	if (rval != QL_SUCCESS) {
@@ -11273,7 +11669,7 @@
 		xp->fdesc.flash_len = 0;
 	}
 
-	QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_3(ha, "done\n");
 
 	return (rval);
 }
@@ -11304,7 +11700,7 @@
 	ql_adapter_state_t	*ha = vha->pha;
 	ql_xioctl_t		*xp = ha->xioctl;
 
-	QL_PRINT_3(CE_CONT, "(%d): started, faddr=%xh, size=%xh\n",
+	QL_PRINT_3(ha, "started, faddr=%xh, size=%xh\n",
 	    ha->instance, faddr, size);
 
 	/* start address must be 32 bit word aligned */
@@ -11314,7 +11710,7 @@
 	}
 
 	/* Allocate DMA buffer */
-	if (CFG_IST(ha, CFG_CTRL_2581)) {
+	if (CFG_IST(ha, CFG_FLASH_DMA_SUPPORT)) {
 		if ((rval = ql_get_dma_mem(ha, &dmabuf, 0xffff,
 		    LITTLE_ENDIAN_DMA, QL_DMA_DATA_ALIGN)) !=
 		    QL_SUCCESS) {
@@ -11323,11 +11719,8 @@
 		}
 	}
 
-	GLOBAL_HW_LOCK();
-
 	/* Enable flash write */
 	if ((rval = ql_24xx_unprotect_flash(ha)) != QL_SUCCESS) {
-		GLOBAL_HW_UNLOCK();
 		EL(ha, "unprotect_flash failed, rval=%xh\n", rval);
 		ql_free_phys(ha, &dmabuf);
 		return (rval);
@@ -11347,7 +11740,7 @@
 	while (cnt < size) {
 		/* Beginning of a sector? */
 		if ((faddr & rest_addr) == 0) {
-			if (CFG_IST(ha, CFG_CTRL_8021)) {
+			if (CFG_IST(ha, CFG_CTRL_82XX)) {
 				fdata = ha->flash_data_addr | faddr;
 				rval = ql_8021_rom_erase(ha, fdata);
 				if (rval != QL_SUCCESS) {
@@ -11357,7 +11750,7 @@
 					    fdata + rest_addr);
 					break;
 				}
-			} else if (CFG_IST(ha, CFG_CTRL_81XX)) {
+			} else if (CFG_IST(ha, CFG_FLASH_ACC_SUPPORT)) {
 				fdata = ha->flash_data_addr | faddr;
 				rval = ql_flash_access(ha,
 				    FAC_ERASE_SECTOR, fdata, fdata +
@@ -11395,7 +11788,7 @@
 		}
 
 		/* Write data */
-		if (CFG_IST(ha, CFG_CTRL_2581) &&
+		if (CFG_IST(ha, CFG_FLASH_DMA_SUPPORT) &&
 		    ((faddr & 0x3f) == 0)) {
 			/*
 			 * Limit write up to sector boundary.
@@ -11446,15 +11839,15 @@
 
 	ql_24xx_protect_flash(ha);
 
-	ql_free_phys(ha, &dmabuf);
+	if (CFG_IST(ha, CFG_FLASH_DMA_SUPPORT)) {
+		ql_free_phys(ha, &dmabuf);
+	}
 
-	GLOBAL_HW_UNLOCK();
-
 	if (rval != QL_SUCCESS) {
 		EL(ha, "failed=%xh\n", rval);
 	} else {
 		/*EMPTY*/
-		QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+		QL_PRINT_3(ha, "done\n");
 	}
 	return (rval);
 }
@@ -11481,7 +11874,7 @@
 	int			rval = QL_SUCCESS;
 	ql_adapter_state_t	*ha = vha->pha;
 
-	if (CFG_IST(ha, CFG_CTRL_8021)) {
+	if (CFG_IST(ha, CFG_CTRL_82XX)) {
 		if ((rval = ql_8021_rom_read(ha, faddr, bp)) != QL_SUCCESS) {
 			EL(ha, "8021 access error\n");
 		}
@@ -11537,7 +11930,7 @@
 	int			rval = QL_SUCCESS;
 	ql_adapter_state_t	*ha = vha->pha;
 
-	if (CFG_IST(ha, CFG_CTRL_8021)) {
+	if (CFG_IST(ha, CFG_CTRL_82XX)) {
 		if ((rval = ql_8021_rom_write(ha, addr, data)) != QL_SUCCESS) {
 			EL(ha, "8021 access error\n");
 		}
@@ -11557,7 +11950,7 @@
 			/* Check flash write in progress. */
 			if ((addr & FLASH_ADDR_MASK) == FLASH_CONF_ADDR) {
 				(void) ql_24xx_read_flash(ha,
-				    FLASH_CONF_ADDR | 0x005, &fdata);
+				    FLASH_CONF_ADDR | 0x105, &fdata);
 				if (!(fdata & BIT_0)) {
 					break;
 				}
@@ -11594,13 +11987,13 @@
 ql_24xx_unprotect_flash(ql_adapter_state_t *vha)
 {
 	int			rval;
-	uint32_t		fdata;
+	uint32_t		fdata, timer;
 	ql_adapter_state_t	*ha = vha->pha;
 	ql_xioctl_t		*xp = ha->xioctl;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
-	if (CFG_IST(ha, CFG_CTRL_8021)) {
+	if (CFG_IST(ha, CFG_CTRL_82XX)) {
 		(void) ql_8021_rom_wrsr(ha, xp->fdesc.write_enable_bits);
 		rval = ql_8021_rom_wrsr(ha, xp->fdesc.write_enable_bits);
 		if (rval != QL_SUCCESS) {
@@ -11608,16 +12001,35 @@
 		}
 		return (rval);
 	}
-	if (CFG_IST(ha, CFG_CTRL_81XX)) {
+	if (CFG_IST(ha, CFG_FLASH_ACC_SUPPORT)) {
 		if (ha->task_daemon_flags & FIRMWARE_UP) {
-			if ((rval = ql_flash_access(ha, FAC_WRT_ENABLE, 0, 0,
-			    0)) != QL_SUCCESS) {
-				EL(ha, "status=%xh\n", rval);
+			for (timer = 3000; timer; timer--) {
+				if (ha->task_daemon_flags & ISP_ABORT_NEEDED) {
+					EL(ha, "ISP_ABORT_NEEDED done\n");
+					return (QL_ABORTED);
+				}
+				rval = ql_flash_access(ha, FAC_SEMA_LOCK,
+				    0, 0, NULL);
+				if (rval == QL_SUCCESS ||
+				    rval == QL_FUNCTION_TIMEOUT) {
+					EL(ha, "lock status=%xh\n", rval);
+					break;
+				}
+				delay(1);
 			}
-			QL_PRINT_3(CE_CONT, "(%d): 8100 done\n",
-			    ha->instance);
-			return (rval);
+
+			if (rval == QL_SUCCESS &&
+			    (rval = ql_flash_access(ha, FAC_WRT_ENABLE, 0,
+			    0, NULL)) != QL_SUCCESS) {
+				EL(ha, "WRT_ENABLE status=%xh\n", rval);
+				(void) ql_flash_access(ha, FAC_SEMA_UNLOCK,
+				    0, 0, NULL);
+			}
+		} else {
+			rval = QL_SUCCESS;
 		}
+		QL_PRINT_3(ha, "CFG_FLASH_ACC_SUPPORT done\n");
+		return (rval);
 	} else {
 		/* Enable flash write. */
 		WRT32_IO_REG(ha, ctrl_status,
@@ -11625,10 +12037,13 @@
 		RD32_IO_REG(ha, ctrl_status);	/* PCI Posting. */
 	}
 
+	/* Sector/Block Protection Register Lock (SST, ST, ATMEL). */
+	(void) ql_24xx_write_flash(ha, FLASH_CONF_ADDR | 0x100 |
+	    xp->fdesc.write_statusreg_cmd, xp->fdesc.write_enable_bits);
+
 	/*
-	 * Remove block write protection (SST and ST) and
-	 * Sector/Block Protection Register Lock (SST, ST, ATMEL).
-	 * Unprotect sectors.
+	 * Remove block write protection (SST and ST)
+	 * Global unprotect sectors (ATMEL).
 	 */
 	(void) ql_24xx_write_flash(ha, FLASH_CONF_ADDR | 0x100 |
 	    xp->fdesc.write_statusreg_cmd, xp->fdesc.write_enable_bits);
@@ -11647,7 +12062,7 @@
 		    xp->fdesc.unprotect_sector_cmd, 0x00800f);
 	}
 
-	QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_3(ha, "done\n");
 
 	return (QL_SUCCESS);
 }
@@ -11666,13 +12081,13 @@
 ql_24xx_protect_flash(ql_adapter_state_t *vha)
 {
 	int			rval;
-	uint32_t		fdata;
+	uint32_t		fdata, timer;
 	ql_adapter_state_t	*ha = vha->pha;
 	ql_xioctl_t		*xp = ha->xioctl;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
-	if (CFG_IST(ha, CFG_CTRL_8021)) {
+	if (CFG_IST(ha, CFG_CTRL_82XX)) {
 		(void) ql_8021_rom_wrsr(ha, xp->fdesc.write_enable_bits);
 		rval = ql_8021_rom_wrsr(ha, xp->fdesc.write_disable_bits);
 		if (rval != QL_SUCCESS) {
@@ -11680,14 +12095,34 @@
 		}
 		return;
 	}
-	if (CFG_IST(ha, CFG_CTRL_81XX)) {
+	if (CFG_IST(ha, CFG_FLASH_ACC_SUPPORT)) {
 		if (ha->task_daemon_flags & FIRMWARE_UP) {
-			if ((rval = ql_flash_access(ha, FAC_WRT_PROTECT, 0, 0,
-			    0)) != QL_SUCCESS) {
-				EL(ha, "status=%xh\n", rval);
+			for (timer = 3000; timer; timer--) {
+				if (ha->task_daemon_flags & ISP_ABORT_NEEDED) {
+					EL(ha, "ISP_ABORT_NEEDED done\n");
+					return;
+				}
+				rval = ql_flash_access(ha, FAC_SEMA_LOCK,
+				    0, 0, NULL);
+				if (rval == QL_SUCCESS ||
+				    rval == QL_FUNCTION_TIMEOUT) {
+					if (rval != QL_SUCCESS) {
+						EL(ha, "lock status=%xh\n",
+						    rval);
+					}
+					break;
+				}
+				delay(1);
 			}
-			QL_PRINT_3(CE_CONT, "(%d): 8100 done\n",
-			    ha->instance);
+
+			if (rval == QL_SUCCESS &&
+			    (rval = ql_flash_access(ha, FAC_WRT_PROTECT, 0,
+			    0, NULL)) != QL_SUCCESS) {
+				EL(ha, "protect status=%xh\n", rval);
+				(void) ql_flash_access(ha, FAC_SEMA_UNLOCK, 0,
+				    0, NULL);
+			}
+			QL_PRINT_3(ha, "CFG_FLASH_ACC_SUPPORT done\n");
 			return;
 		}
 	} else {
@@ -11705,31 +12140,31 @@
 	if (xp->fdesc.protect_sector_cmd != 0) {
 		for (fdata = 0; fdata < 0x10; fdata++) {
 			(void) ql_24xx_write_flash(ha, FLASH_CONF_ADDR |
-			    0x330 | xp->fdesc.protect_sector_cmd, fdata);
+			    0x300 | xp->fdesc.protect_sector_cmd, fdata);
 		}
-		(void) ql_24xx_write_flash(ha, FLASH_CONF_ADDR | 0x330 |
+		(void) ql_24xx_write_flash(ha, FLASH_CONF_ADDR | 0x300 |
 		    xp->fdesc.protect_sector_cmd, 0x00400f);
-		(void) ql_24xx_write_flash(ha, FLASH_CONF_ADDR | 0x330 |
+		(void) ql_24xx_write_flash(ha, FLASH_CONF_ADDR | 0x300 |
 		    xp->fdesc.protect_sector_cmd, 0x00600f);
-		(void) ql_24xx_write_flash(ha, FLASH_CONF_ADDR | 0x330 |
+		(void) ql_24xx_write_flash(ha, FLASH_CONF_ADDR | 0x300 |
 		    xp->fdesc.protect_sector_cmd, 0x00800f);
-
-		/* TODO: ??? */
-		(void) ql_24xx_write_flash(ha,
-		    FLASH_CONF_ADDR | 0x101, 0x80);
-	} else {
-		(void) ql_24xx_write_flash(ha,
-		    FLASH_CONF_ADDR | 0x101, 0x9c);
 	}
 
+	/* Remove Sector Protection Registers Locked (SPRL) bit. */
+	(void) ql_24xx_write_flash(ha, FLASH_CONF_ADDR | 0x100 |
+	    xp->fdesc.write_statusreg_cmd, xp->fdesc.write_enable_bits);
+
+	(void) ql_24xx_write_flash(ha, FLASH_CONF_ADDR | 0x100 |
+	    xp->fdesc.write_statusreg_cmd, xp->fdesc.write_disable_bits);
+
 	/* Disable flash write. */
-	if (!(CFG_IST(ha, CFG_CTRL_81XX))) {
+	if (!CFG_IST(ha, CFG_FLASH_ACC_SUPPORT)) {
 		WRT32_IO_REG(ha, ctrl_status,
 		    RD32_IO_REG(ha, ctrl_status) & ~ISP_FLASH_ENABLE);
 		RD32_IO_REG(ha, ctrl_status);	/* PCI Posting. */
 	}
 
-	QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_3(ha, "done\n");
 }
 
 /*
@@ -11745,7 +12180,7 @@
  * Context:
  *	Kernel context.
  */
-static int
+int
 ql_dump_firmware(ql_adapter_state_t *vha)
 {
 	int			rval;
@@ -11752,7 +12187,7 @@
 	clock_t			timer = drv_usectohz(30000000);
 	ql_adapter_state_t	*ha = vha->pha;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
 	QL_DUMP_LOCK(ha);
 
@@ -11759,7 +12194,7 @@
 	if (ha->ql_dump_state & QL_DUMPING ||
 	    (ha->ql_dump_state & QL_DUMP_VALID &&
 	    !(ha->ql_dump_state & QL_DUMP_UPLOADED))) {
-		QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+		QL_PRINT_3(ha, "done\n");
 		QL_DUMP_UNLOCK(ha);
 		return (QL_SUCCESS);
 	}
@@ -11766,18 +12201,18 @@
 
 	QL_DUMP_UNLOCK(ha);
 
-	ql_awaken_task_daemon(ha, NULL, DRIVER_STALL, 0);
+	(void) ql_stall_driver(ha, 0);
 
-	/*
-	 * Wait for all outstanding commands to complete
-	 */
-	(void) ql_wait_outstanding(ha);
-
 	/* Dump firmware. */
-	rval = ql_binary_fw_dump(ha, TRUE);
+	if (CFG_IST(ha, CFG_CTRL_82XX)) {
+		rval = ql_binary_fw_dump(ha, FALSE);
+	} else {
+		rval = ql_binary_fw_dump(ha, TRUE);
+	}
 
 	/* Do abort to force restart. */
-	ql_awaken_task_daemon(ha, NULL, ISP_ABORT_NEEDED, DRIVER_STALL);
+	ql_restart_driver(ha);
+	ql_awaken_task_daemon(ha, NULL, ISP_ABORT_NEEDED, 0);
 	EL(ha, "restarting, isp_abort_needed\n");
 
 	/* Acquire task daemon lock. */
@@ -11784,7 +12219,7 @@
 	TASK_DAEMON_LOCK(ha);
 
 	/* Wait for suspension to end. */
-	while (ha->task_daemon_flags & QL_SUSPENDED) {
+	while (DRIVER_SUSPENDED(ha)) {
 		ha->task_daemon_flags |= SUSPENDED_WAKEUP_FLG;
 
 		/* 30 seconds from now */
@@ -11804,7 +12239,7 @@
 
 	if (rval == QL_SUCCESS || rval == QL_DATA_EXISTS) {
 		/*EMPTY*/
-		QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+		QL_PRINT_3(ha, "done\n");
 	} else {
 		EL(ha, "failed, rval = %xh\n", rval);
 	}
@@ -11828,15 +12263,18 @@
 int
 ql_binary_fw_dump(ql_adapter_state_t *vha, int lock_needed)
 {
+	uint32_t		cnt, index;
 	clock_t			timer;
-	mbx_cmd_t		mc;
-	mbx_cmd_t		*mcp = &mc;
 	int			rval = QL_SUCCESS;
 	ql_adapter_state_t	*ha = vha->pha;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
-	if (CFG_IST(ha, CFG_CTRL_8021)) {
+	ADAPTER_STATE_LOCK(ha);
+	ha->flags &= ~FW_DUMP_NEEDED;
+	ADAPTER_STATE_UNLOCK(ha);
+
+	if (CFG_IST(ha, CFG_CTRL_82XX) && ha->md_capture_size == 0) {
 		EL(ha, "8021 not supported\n");
 		return (QL_NOT_SUPPORTED);
 	}
@@ -11857,10 +12295,9 @@
 	QL_DUMP_UNLOCK(ha);
 
 	if (CFG_IST(ha, CFG_ENABLE_FWEXTTRACE)) {
-
 		/* Insert Time Stamp */
 		rval = ql_fw_etrace(ha, &ha->fwexttracebuf,
-		    FTO_INSERT_TIME_STAMP);
+		    FTO_INSERT_TIME_STAMP, NULL);
 		if (rval != QL_SUCCESS) {
 			EL(ha, "f/w extended trace insert"
 			    "time stamp failed: %xh\n", rval);
@@ -11870,7 +12307,7 @@
 	if (lock_needed == TRUE) {
 		/* Acquire mailbox register lock. */
 		MBX_REGISTER_LOCK(ha);
-		timer = (ha->mcp->timeout + 2) * drv_usectohz(1000000);
+		timer = ((MAILBOX_TOV + 6) * drv_usectohz(1000000));
 
 		/* Check for mailbox available, if not wait for signal. */
 		while (ha->mailbox_flags & MBX_BUSY_FLG) {
@@ -11898,8 +12335,6 @@
 		/* Set busy flag. */
 		ha->mailbox_flags = (uint8_t)
 		    (ha->mailbox_flags | MBX_BUSY_FLG);
-		mcp->timeout = 120;
-		ha->mcp = mcp;
 
 		/* Release mailbox register lock. */
 		MBX_REGISTER_UNLOCK(ha);
@@ -11911,33 +12346,70 @@
 		ha->ql_dump_ptr = NULL;
 	}
 
-	if (CFG_IST(ha, CFG_CTRL_2422)) {
+	if (CFG_IST(ha, CFG_CTRL_24XX)) {
 		ha->ql_dump_size = (uint32_t)(sizeof (ql_24xx_fw_dump_t) +
 		    ha->fw_ext_memory_size);
 	} else if (CFG_IST(ha, CFG_CTRL_25XX)) {
+		cnt = ha->rsp_queues_cnt > 1 ? ha->req_q[0]->req_ring.size +
+		    ha->req_q[1]->req_ring.size : ha->req_q[0]->req_ring.size;
+		index = ha->rsp_queues[0]->rsp_ring.size * ha->rsp_queues_cnt;
+
 		ha->ql_dump_size = (uint32_t)(sizeof (ql_25xx_fw_dump_t) +
-		    ha->fw_ext_memory_size);
+		    cnt + index + ha->fw_ext_memory_size +
+		    (ha->rsp_queues_cnt * 16));
+
 	} else if (CFG_IST(ha, CFG_CTRL_81XX)) {
+		cnt = ha->rsp_queues_cnt > 1 ? ha->req_q[0]->req_ring.size +
+		    ha->req_q[1]->req_ring.size : ha->req_q[0]->req_ring.size;
+		index = ha->rsp_queues[0]->rsp_ring.size * ha->rsp_queues_cnt;
+
 		ha->ql_dump_size = (uint32_t)(sizeof (ql_81xx_fw_dump_t) +
-		    ha->fw_ext_memory_size);
+		    cnt + index + ha->fw_ext_memory_size +
+		    (ha->rsp_queues_cnt * 16));
+
+	} else if (CFG_IST(ha, CFG_CTRL_83XX)) {
+		cnt = ha->rsp_queues_cnt > 1 ? ha->req_q[0]->req_ring.size +
+		    ha->req_q[1]->req_ring.size : ha->req_q[0]->req_ring.size;
+		index = ha->rsp_queues[0]->rsp_ring.size * ha->rsp_queues_cnt;
+
+		ha->ql_dump_size = (uint32_t)(sizeof (ql_83xx_fw_dump_t) +
+		    cnt + index + ha->fw_ext_memory_size +
+		    (ha->rsp_queues_cnt * 16));
+	} else if (CFG_IST(ha, CFG_CTRL_82XX)) {
+		ha->ql_dump_size = ha->md_capture_size;
 	} else {
 		ha->ql_dump_size = sizeof (ql_fw_dump_t);
 	}
 
-	if ((ha->ql_dump_ptr = kmem_zalloc(ha->ql_dump_size, KM_NOSLEEP)) ==
-	    NULL) {
-		rval = QL_MEMORY_ALLOC_FAILED;
+	if (CFG_IST(ha, CFG_CTRL_27XX)) {
+		rval = ql_27xx_binary_fw_dump(ha);
 	} else {
-		if (CFG_IST(ha, (CFG_CTRL_2300 | CFG_CTRL_6322))) {
-			rval = ql_2300_binary_fw_dump(ha, ha->ql_dump_ptr);
-		} else if (CFG_IST(ha, CFG_CTRL_81XX)) {
-			rval = ql_81xx_binary_fw_dump(ha, ha->ql_dump_ptr);
-		} else if (CFG_IST(ha, CFG_CTRL_25XX)) {
-			rval = ql_25xx_binary_fw_dump(ha, ha->ql_dump_ptr);
-		} else if (CFG_IST(ha, CFG_CTRL_2422)) {
-			rval = ql_24xx_binary_fw_dump(ha, ha->ql_dump_ptr);
+		if ((ha->ql_dump_ptr =
+		    kmem_zalloc(ha->ql_dump_size, KM_NOSLEEP)) == NULL) {
+			rval = QL_MEMORY_ALLOC_FAILED;
 		} else {
-			rval = ql_2200_binary_fw_dump(ha, ha->ql_dump_ptr);
+			if (CFG_IST(ha, CFG_CTRL_2363)) {
+				rval = ql_2300_binary_fw_dump(ha,
+				    ha->ql_dump_ptr);
+			} else if (CFG_IST(ha, CFG_CTRL_81XX)) {
+				rval = ql_81xx_binary_fw_dump(ha,
+				    ha->ql_dump_ptr);
+			} else if (CFG_IST(ha, CFG_CTRL_83XX)) {
+				rval = ql_83xx_binary_fw_dump(ha,
+				    ha->ql_dump_ptr);
+			} else if (CFG_IST(ha, CFG_CTRL_25XX)) {
+				rval = ql_25xx_binary_fw_dump(ha,
+				    ha->ql_dump_ptr);
+			} else if (CFG_IST(ha, CFG_CTRL_24XX)) {
+				rval = ql_24xx_binary_fw_dump(ha,
+				    ha->ql_dump_ptr);
+			} else if (CFG_IST(ha, CFG_CTRL_82XX)) {
+				(void) ql_8021_reset_fw(ha);
+				rval = QL_SUCCESS;
+			} else {
+				rval = ql_2200_binary_fw_dump(ha,
+				    ha->ql_dump_ptr);
+			}
 		}
 	}
 
@@ -11988,18 +12460,26 @@
 	ql_adapter_state_t	*ha = vha->pha;
 	ql_fw_dump_t		*fw = ha->ql_dump_ptr;
 
-	if (CFG_IST(ha, CFG_CTRL_2422)) {
+	if (CFG_IST(ha, CFG_CTRL_24XX)) {
 		return (ql_24xx_ascii_fw_dump(ha, bufp));
-	} else if (CFG_IST(ha, CFG_CTRL_2581)) {
-		return (ql_2581_ascii_fw_dump(ha, bufp));
+	} else if (CFG_IST(ha, CFG_CTRL_25XX)) {
+		return (ql_25xx_ascii_fw_dump(ha, bufp));
+	} else if (CFG_IST(ha, CFG_CTRL_81XX)) {
+		return (ql_81xx_ascii_fw_dump(ha, bufp));
+	} else if (CFG_IST(ha, CFG_CTRL_82XX)) {
+		return (ql_8021_ascii_fw_dump(ha, bufp));
+	} else if (CFG_IST(ha, CFG_CTRL_83XX)) {
+		return (ql_83xx_ascii_fw_dump(ha, bufp));
+	} else if (CFG_IST(ha, CFG_CTRL_27XX)) {
+		return (ql_27xx_ascii_fw_dump(ha, bufp));
 	}
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
-	if (CFG_IST(ha, CFG_CTRL_2300)) {
+	if (CFG_IST(ha, CFG_CTRL_23XX)) {
 		(void) sprintf(bufp, "\nISP 2300IP ");
-	} else if (CFG_IST(ha, CFG_CTRL_6322)) {
-		(void) sprintf(bufp, "\nISP 6322FLX ");
+	} else if (CFG_IST(ha, CFG_CTRL_63XX)) {
+		(void) sprintf(bufp, "\nISP 2322/6322FLX ");
 	} else {
 		(void) sprintf(bufp, "\nISP 2200IP ");
 	}
@@ -12019,7 +12499,7 @@
 		bp = bp + 6;
 	}
 
-	if (CFG_IST(ha, (CFG_CTRL_2300 | CFG_CTRL_6322))) {
+	if (CFG_IST(ha, CFG_CTRL_2363)) {
 		(void) strcat(bufp, "\n\nReqQ-RspQ-Risc2Host Status "
 		    "registers:");
 		bp = bufp + strlen(bufp);
@@ -12034,7 +12514,7 @@
 
 	(void) strcat(bp, "\n\nMailbox Registers:");
 	bp = bufp + strlen(bufp);
-	mbox_cnt = (CFG_IST(ha, (CFG_CTRL_2300 | CFG_CTRL_6322))) ? 16 : 8;
+	mbox_cnt = CFG_IST(ha, CFG_CTRL_2363) ? 16 : 8;
 	for (cnt = 0; cnt < mbox_cnt; cnt++) {
 		if (cnt % 8 == 0) {
 			*bp++ = '\n';
@@ -12043,7 +12523,7 @@
 		bp = bp + 6;
 	}
 
-	if (CFG_IST(ha, (CFG_CTRL_2300 | CFG_CTRL_6322))) {
+	if (CFG_IST(ha, CFG_CTRL_2363)) {
 		(void) strcat(bp, "\n\nAuto Request Response DMA Registers:");
 		bp = bufp + strlen(bufp);
 		for (cnt = 0; cnt < sizeof (fw->resp_dma_reg) / 2; cnt++) {
@@ -12158,8 +12638,7 @@
 	(void) strcat(bp, "\n\nFrame Buffer Hardware Registers:");
 	bp = bufp + strlen(bufp);
 	for (cnt = 0; cnt < sizeof (fw->frame_buf_hdw_reg) / 2; cnt++) {
-		if ((cnt == 16) && ((CFG_IST(ha, (CFG_CTRL_2300 |
-		    CFG_CTRL_6322)) == 0))) {
+		if (cnt == 16 && !CFG_IST(ha, CFG_CTRL_2363)) {
 			break;
 		}
 		if (cnt % 8 == 0) {
@@ -12189,7 +12668,7 @@
 		bp = bp + 6;
 	}
 
-	if (CFG_IST(ha, (CFG_CTRL_2300 | CFG_CTRL_6322))) {
+	if (CFG_IST(ha, CFG_CTRL_2363)) {
 		(void) strcat(bp, "\n\nCode RAM Dump:");
 		bp = bufp + strlen(bufp);
 		for (cnt = 0; cnt < sizeof (fw->risc_ram) / 2; cnt++) {
@@ -12262,7 +12741,7 @@
 
 	(void) sprintf(bp, "\n");
 
-	QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_10(ha, "done, size=0x%x\n", strlen(bufp));
 
 	return (strlen(bufp));
 }
@@ -12288,7 +12767,7 @@
 	caddr_t			bp = bufp;
 	ql_24xx_fw_dump_t	*fw = ha->ql_dump_ptr;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
 	(void) sprintf(bp, "ISP FW Version %d.%02d.%02d Attributes %X\n",
 	    ha->fw_major_version, ha->fw_minor_version,
@@ -12676,14 +13155,14 @@
 
 	cnt = (uint32_t)((uintptr_t)bp - (uintptr_t)bufp);
 
-	QL_PRINT_3(CE_CONT, "(%d): done=%xh\n", ha->instance, cnt);
+	QL_PRINT_10(ha, "done=%xh\n", cnt);
 
 	return (cnt);
 }
 
 /*
- * ql_2581_ascii_fw_dump
- *	Converts ISP25xx or ISP81xx firmware binary dump to ascii.
+ * ql_25xx_ascii_fw_dump
+ *	Converts ISP25xx firmware binary dump to ascii.
  *
  * Input:
  *	ha = adapter state pointer.
@@ -12696,14 +13175,13 @@
  *	Kernel context.
  */
 static size_t
-ql_2581_ascii_fw_dump(ql_adapter_state_t *ha, caddr_t bufp)
+ql_25xx_ascii_fw_dump(ql_adapter_state_t *ha, caddr_t bufp)
 {
-	uint32_t		cnt;
-	uint32_t		cnt1;
+	uint32_t		cnt, cnt1, *dp, *dp2;
 	caddr_t			bp = bufp;
 	ql_25xx_fw_dump_t	*fw = ha->ql_dump_ptr;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
 	(void) sprintf(bp, "\nISP FW Version %d.%02d.%02d Attributes %X\n",
 	    ha->fw_major_version, ha->fw_minor_version,
@@ -12710,9 +13188,16 @@
 	    ha->fw_subminor_version, ha->fw_attributes);
 	bp += strlen(bp);
 
+	(void) sprintf(bp, "\nHCCR Register\n%08x\n", fw->hccr);
+	bp += strlen(bp);
+
 	(void) sprintf(bp, "\nR2H Status Register\n%08x\n", fw->r2h_status);
 	bp += strlen(bp);
 
+	(void) sprintf(bp, "\nAER Uncorrectable Error Status Register\n%08x\n",
+	    fw->aer_ues);
+	bp += strlen(bp);
+
 	(void) sprintf(bp, "\nHostRisc Registers");
 	bp += strlen(bp);
 	for (cnt = 0; cnt < sizeof (fw->hostrisc_reg) / 4; cnt++) {
@@ -12883,7 +13368,7 @@
 		if (cnt % 8 == 0) {
 			(void) sprintf(bp++, "\n");
 		}
-		(void)  sprintf(bp, "%08x ", fw->cmd_dma_reg[cnt]);
+		(void) sprintf(bp, "%08x ", fw->cmd_dma_reg[cnt]);
 		bp += 9;
 	}
 
@@ -13019,9 +13504,7 @@
 
 	(void) sprintf(bp, "\n\nFPM Hardware Registers");
 	bp += strlen(bp);
-	cnt1 = CFG_IST(ha, CFG_CTRL_81XX) ?
-	    (uint32_t)(sizeof (((ql_81xx_fw_dump_t *)(fw))->fpm_hdw_reg)) :
-	    (uint32_t)(sizeof (fw->fpm_hdw_reg));
+	cnt1 = sizeof (fw->fpm_hdw_reg);
 	for (cnt = 0; cnt < cnt1 / 4; cnt++) {
 		if (cnt % 8 == 0) {
 			(void) sprintf(bp++, "\n");
@@ -13032,9 +13515,7 @@
 
 	(void) sprintf(bp, "\n\nFB Hardware Registers");
 	bp += strlen(bp);
-	cnt1 = CFG_IST(ha, CFG_CTRL_81XX) ?
-	    (uint32_t)(sizeof (((ql_81xx_fw_dump_t *)(fw))->fb_hdw_reg)) :
-	    (uint32_t)(sizeof (fw->fb_hdw_reg));
+	cnt1 = sizeof (fw->fb_hdw_reg);
 	for (cnt = 0; cnt < cnt1 / 4; cnt++) {
 		if (cnt % 8 == 0) {
 			(void) sprintf(bp++, "\n");
@@ -13056,12 +13537,14 @@
 
 	(void) sprintf(bp, "\n\nExternal Memory");
 	bp += strlen(bp);
+	dp = (uint32_t *)((caddr_t)fw->req_rsp_ext_mem + fw->req_q_size[0] +
+	    fw->req_q_size[1] + fw->rsp_q_size + (ha->rsp_queues_cnt * 16));
 	for (cnt = 0; cnt < ha->fw_ext_memory_size / 4; cnt++) {
 		if (cnt % 8 == 0) {
 			(void) sprintf(bp, "\n%08x: ", cnt + 0x100000);
 			bp += 11;
 		}
-		(void) sprintf(bp, "%08x ", fw->ext_mem[cnt]);
+		(void) sprintf(bp, "%08x ", *dp++);
 		bp += 9;
 	}
 
